********************************************************************************
*** Sistema...: Exemplo FireBird                                             ***
*** Programa..: FUNC_SQL.PRG                                                 ***
*** Data......: 28/03/2019                                                   ***
*** Mdulo....: Criao e restruturao das tabelas                          ***
********************************************************************************

#xcommand DEFAULT <uVar1> := <uVal1> ;
             [, <uVarN> := <uValN> ] ;
          => ;
          <uVar1> := IIf( <uVar1> == nil, <uVal1>, <uVar1> ) ;;
          [ <uVarN> := IIf( <uVarN> == nil, <uValN>, <uVarN> ); ]


/******************************************************************************/    
FUNCTION CRIA_ARQUIVOS()
/******************************************************************************/       
   LOCAL  aPovoador:={}, handle, lTrigger1 := .F., lTrigger2 := .F., lTrigger3 := .F.
   Static cNome_Tabela, vSql

***
*** Arquivo com cadastro de Produtos OK
***
   cNome_Tabela:="PRODUTOS"  
   vSql := 'CREATE TABLE '+cNome_Tabela+' ('
   vSql += 'PRCODI VarChar(6) Not Null, '    && Cdigo interno do produto
   vSql += 'CODBARRA VarChar(14), '          && Cdigo de Barras
   vSql += 'PRDESC VarChar(30), '            && Descrio Comercial
   vSql += 'NOMELAB VarChar(30), '           && Nome do Laboratrio
   vSql += 'PRESTQ Float, '                  && Estoque
   vSql += 'PRCONS Float, '                  && Preo de venda
   vSql += 'CONSTRAINT PK_'+cNome_tabela+' PRIMARY KEY(PRCODI) )'
   if !oSql:TABLEExists(cNome_Tabela)
      *---> Criando a tabela <---*
      oDlg:=GetActiveWindow()
      SetWindowText( oDlg, "Verificando a tabela, "+cNome_Tabela )
      ExecSqlTbl(vSql, cNome_Tabela)
   Endif

RETURN .T.

/******************************************************************************/
Function ExecSqlTbl(xSql, cTabela, lTrigger)
/******************************************************************************/
LOCAL n, cFile, handle
   
   DEFAULT lTrigger := .F.
   
   oSql:StartTransaction()   && Starta uma Transao
   oSql:Execute( xSql )      && Executa a operao no banco
   
   if oSql:NetErr()          && Verifica se ocorreu erro
      n:=1
      cFile:=".\ERRO_"+StrZero(n,4)+".Sql"
      while File(cFile)
         n++
         cFile:=".\ERRO_"+StrZero(n,4)+".Sql"
      end

      *---> Grava o arquivo com os comandos <---*
      handle := fcreate(cFile)
      fwrite(handle, xSql )
      fClose(Handle)
      
      if !lTrigger
         MsgExclamation('Problema na criao da tabela '+cTabela,'Erro')
      endif
      
      oSql:Rollback()   && Volta o processo
      
   else
      
      oSql:Commit()     && Atualiza o banco
      
   endif
   
Return(.t.)      

/******************************************************************************/
static Function StructureTable(nTable, vArrayTable)
/******************************************************************************/
Local xTemp, xTemp2 := 0, nFields := 0, Encontrado, cChave:=""

   *---> Deleta as chaves primaria para alterar a tabela <---*
   oSql:StartTransaction()
   vSql := 'ALTER TABLE '+nTable+' DROP CONSTRAINT PK_'+nTable
   oSql:Execute( vSql )
   oSql:Commit()
   oQuery := oSql:Query( 'Select * FROM '+nTable )
   AGets := Array(oQuery:Fcount())
   
   //Verificando se existe novos Campos
   oSql:StartTransaction()
   For xTemp := 1 to Len(vArrayTable)
      Encontrado := .f.
      If vArrayTable[xTemp,4]  // Primary Key
         cChave += if(empty(cChave),vArrayTable[xTemp,1],', '+vArrayTable[xTemp,1])
      Endif
      For xTemp2 := 1 To oQuery:Fcount()
         if vArrayTable[xTemp,1] == oQuery:FieldName(xTemp2)
            Encontrado := .t.
            xTemp2 := Len(vArrayTable)
         endif
      Next
      if !Encontrado
         vSql := 'ALTER TABLE '+nTable+CRLF
         vSql += 'ADD '+vArrayTable[xTemp,1]+' '+;
                        vArrayTable[xTemp,2]+;
                        if(vArrayTable[xTemp,3]>0,'('+AllTrim(Str(vArrayTable[xTemp,3]))+')','')+if(vArrayTable[xTemp,4],' NOT NULL','')
         oSql:Execute( vSql )
      else

         vSql := 'ALTER TABLE '+nTable+' ALTER '+vArrayTable[xTemp,1]+' TYPE '+vArrayTable[xTemp,2]+if(vArrayTable[xTemp,3]>0,'('+AllTrim(Str(vArrayTable[xTemp,3]))+')','')
         oSql:Execute( vSql )
         If vArrayTable[xTemp,4]  // Primary Key Not Null
            vSql := "update RDB$RELATION_FIELDS set RDB$NULL_FLAG = 1 where (RDB$FIELD_NAME = '"+vArrayTable[xTemp,1]+"') and (RDB$RELATION_NAME = '"+nTable+"')"
         else   
            vSql := "update RDB$RELATION_FIELDS set RDB$NULL_FLAG = NULL where (RDB$FIELD_NAME = '"+vArrayTable[xTemp,1]+"') and (RDB$RELATION_NAME = '"+nTable+"')"
         endif
         oSql:Execute( vSql )
      Endif
   Next
   oSql:Commit()
   //ALTER TABLE TABLE002 DROP NOVOCAMPO  
   //Verificar Campos Obsoletos  
   oSql:StartTransaction()
   For xTemp := 1 to oQuery:Fcount()
      Encontrado := .f.
      if xTemp <= Len(vArrayTable)
         For xTemp2 := 1 To Len(vArrayTable)
            if vArrayTable[xTemp,1] == oQuery:FieldName(xTemp2)
               Encontrado := .t.
               xTemp2 := oQuery:Fcount()
            endif
         Next
      endif
      if !Encontrado
         vSql := 'ALTER TABLE '+nTable+CRLF
         vSql += 'DROP '+oQuery:FieldName(xTemp)
         oSql:Execute( vSql )
      Endif
   Next
   oSql:Commit()
   
   *---> Recria as chaves primaria da tabela <---*
   if !empty(cChave)
      oSql:StartTransaction()
      vSql := 'ALTER TABLE '+nTable+CRLF
      vSql += 'ADD CONSTRAINT PK_'+nTable+' PRIMARY KEY('+cChave+')'
      oSql:Execute( vSql )
      oSql:Commit()
   endif
   
Return(.t.)

/******************************************************************************/    
FUNCTION Restrutura_Table()
/******************************************************************************/       
   Static cNome_Tabela := "", vSql := "", vArrayTable := {}

***
*** Arquivo com cadastro de Produtos OK
***
   cNome_Tabela :="PRODUTOS"  
   vArrayTable  := {}
   Aadd(vArrayTable,{'PRCODI'      ,'VarChar', 06, .T.})
   Aadd(vArrayTable,{'PRDESC'      ,'VarChar', 30, .F.})
   Aadd(vArrayTable,{'CODBARRA'    ,'VarChar', 14, .F.})
   Aadd(vArrayTable,{'NOMELAB'     ,'VarChar', 30, .F.})
   StructureTable(cNome_Tabela, vArrayTable)   

RETURN .T.


/******************************************************************************/
FUNCTION PEGA_STRU( cTabela, lNovo, SqlWhere, aGETS, cOpcao  )   //PEGA NOVO REGISTRO E ESTURURAS
/******************************************************************************/
/* 
   cTabela  = oQuery da Tabela com as informaes
   lNovo    = Varivel lgica para adicionar um registro novo
   SqlWhere = Condio do Where para filtragem
   aGETS    = Array que receber os campos da tabela
   cOpcao   = Opo 1 Faz o select e carrega o conteudo dos campos e 2 carrega apenas os objetos
*/
LOCAL nl:=0, X:=0, oRow:=cTabela, cQuery
   DEFAULT cOpcao:=1
 
   aGETS:={}
   TRY
     IF lNovo
        oRow := cTabela:Blank()
     ELSE
        oRow := oSql:Query( "SELECT * FROM " + cTabela[16,1] + " Where " + SqlWhere )
        oRow:Skip()
     ENDIF
   CATCH
     MsgExclamation("Falha na execuo do Query","Ateno")   
     return
   END  
   
   aGETS:=ARRAY( oRow:Fcount() )
	
	try 
     if lNovo
        *---> Inicializa o Array vazio <---*
        AEVAL( aGETS,{ |X,nl| aGETS[nl] := if( oRow:Fieldtype(nl) == "C",;
                                           space(oRow:Fieldlen(nl) ) ,;
                                           if( oRow:Fieldtype(nl) == "N",;
                                           0, date() ) ) } )
     else
        *---> Inicializa o Array com o contedo do campo <---*
        AEVAL( aGETS,{ |X,nl| aGETS[nl] := IIF( oRow:Fieldtype(nl) == "C",;
                                           IIF( oRow:Fieldget(nl)  == nil, space( oRow:Fieldlen(nl) ), oRow:Fieldget(nl) ),;
                                           IIF( oRow:Fieldtype(nl) == "N",;
                                           IIF( oRow:Fieldget(nl)  == nil, 0, oRow:Fieldget(nl) ),;
                                           IIF( oRow:Fieldget(nl)  == nil, date(), oRow:Fieldget(nl) ) ) ) } )
     endif
   Catch
     MsgExclamation('Falha no preenchimento das variavis','Ateno')
   End
   
RETURN

/******************************************************************************/
FUNCTION CHECA_GET( cTabela, SqlWhere )   //Checa a existncia do registro no banco
/******************************************************************************/
/* 
   cTabela  = oQuery da Tabela com as informaes
   SqlWhere = Condio do Where para filtragem
*/
Local lRet := .T., oRow
   TRY
      *---> Faz o Filtro na Tabela para verificar a existencia do registro <---*
      oRow:=oSql:Query( "SELECT * FROM " + cTabela[16,1] + " Where " + SqlWhere )
      oRow:Skip()
      if !oRow:eof()
         MsgInfo( "Registro j Cadastrado " + oRow:FieldGet(1) ,"Ateno" )
         lRet := .F.
      endif
      oRow:Close()
   CATCH
      MsgExclamation( "Falha na consulta da tabela " + cTabela[16,1] ,"Ateno" )
      lRet := .F.
   END   
RETURN lRet

/******************************************************************************/
FUNCTION SALVA_GETS(lNovo, aGETS, cTabela, vChave, CampoCodAut, TamCodAut, xDigito)  // Salvar as informaes no banco
/******************************************************************************/
/* 
   lNovo    = .T. Informa se  um registro ou .F. para edio
   aGETS    = Array com as informaes para gravao
   cTabela  = oQuery da Tabela com as informaes
   vChave   = Array Chave para edio (Indicando posicao dos Campos
   CampoCodAut = Nome do Campo usado para gerar o codigo automatico
   TamCodAut   = Tamanho(parte) do Campo que ser usado para gerar o codigo automatico
   xDigito  = Define se o cdigo automtica receber digito (repassar .t. ou .f.)
*/
LOCAL vSql, X , nl, LRet := .t., vDtAt, QtdeCampos := 0, xSQL_Query, oQueryComando
  
  DEFAULT lNovo     := .T.
  DEFAULT vChave    := {1}
  DEFAULT xDigito   := .F.
  
  *---> Conta a quantidade de campos da tabela <---*  // Wand 10/10/2012 as 11:26
  xSQL_Query    := 'Select * FROM '+ cTabela[16,1]
  oQueryComando := oSql:Query( xSQL_Query )
  QtdeCampos    := oQueryComando:fCount()
  *------------------------------------------------*
  
  if CampoCodAut != NIL
     DEFAULT TamCodAut := cTabela:Fieldlen(cTabela:Fieldpos(CampoCodAut))
  endif
  if lNovo .and. CampoCodAut != Nil
     xCod := CodGeral(cTabela, CampoCodAut, TamCodAut)
     xCmp := cTabela:Fieldpos(CampoCodAut)
     if xDigito 
        aGets[xCmp] := StrZero(xCod,TamCodAut)+RetornaDigito(xCod)
     Else
        aGets[xCmp] := StrZero(xCod,TamCodAut)
     Endif
     CampoCodAut := aGets[xCmp]
  Endif
  Try
    If lNovo
       vSql := "Insert Into "+cTabela[16,1]+ " ("
       For x := 1 To QtdeCampos //cTabela:fCount() - Wand 10/10/2012 as 10:25
           vSql += iif(x>1,',','')+ctabela:Fieldname(x)
       Next
       vSql += ') Values ('
    else
       vSql := "Update "+cTabela[16,1]+ "  Set "
    Endif
    For x := 1 To QtdeCampos //cTabela:fCount() - Wand 10/10/2012 as 10:25
        if cTabela:Fieldtype(x) $ 'CVTBM' 
           vSql += iif(x>1,', ','')+iif(!lNovo,ctabela:Fieldname(x)+'=','')+Aspa+AllTrim(StrTran(aGets[x],"'",'"'))+Aspa
        elseif cTabela:Fieldtype(x) $ 'D' 
           if left(Dtoc(aGets[x]),2) == "  "
              vSql  += iif(x>1,', ','')+iif(!lNovo,ctabela:Fieldname(x)+'=','')+'NULL'
           else
              vDtAt := SubStr(Dtoc(aGets[x]),4,2)+'/'+Left(Dtoc(aGets[x]),2)+'/'+right(Dtoc(aGets[x]),4)
              vSql  += iif(x>1,', ','')+iif(!lNovo,ctabela:Fieldname(x)+'=','')+Aspa+vDtAt+Aspa
           endif
        else
           xValor := StrTran( Str(aGets[x]),',','.' )
           vSql += iif(x>1,', ','')+iif(!lNovo,ctabela:Fieldname(x)+'=','')+xValor     //aGets[x]
        Endif
    Next
    vSql += iif(lNovo,')','')
    if !lNovo 
       vSql += ' Where '   //+vChave
       For X := 1 to Len(vChave)
           //Se Where tratar-se de Data fazer conversao de aGets[s] para formato AAAA/MM/DD
           vSql += iif(x>1,' and ','')+ctabela:FieldName(vChave[x])+'='+iif(ValType(aGets[x])=="N",Str(aGets[x]),Aspa+aGets[x]+Aspa)
       Next
    Endif
    oSql:StartTransaction()
    //handle := fcreate('SALVA.TXT')
    //fwrite(handle,vSql)
    //fClose(handle)
    oRow := oSql:Execute( vSql )
    oSql:Commit()
Catch
  MsgExclamation(oSql:Error(),'Ateno')
  lRet := .f.
  OSql:RoolBack()
End
RETURN(lRet)

/******************************************************************************/    
Function Db_Excluir ( _oXbrowse, cTabela, SqlWhere, cMensag )  // Excluso dos registros da tabela
/******************************************************************************/    
/* 
  _oXbrowse = Objeto do xBrowser
   cTabela  = oQuery da Tabela com as informaes
   SqlWhere = Condio do Where para filtragem
   cMensag  = Mensagem para ser exibida na funo MsgYesNo
*/
LOCAL lRet := .F., xQuery
DEFAULT cMensag := "Deseja Excluir o Registro?"
if valtype(cTabela) != "C"
   cTabela := cTabela[16,1]
endif
try
	IF MSGYESNO( cMensag , "Ateno" )
      
      *---> Deleta do banco de dados <---*
      oSql:StartTransaction()
      xQuery := oSql:EXECUTE( "DELETE FROM " + cTabela + " where " + SqlWhere )
      oSql:Commit()
      
      oDlg:=GetActiveWindow()
      //oDlg:Refresh()
      lret := .T.
   
   EndIf
Catch
   MsgExclamation('Falha na excluso do Registro.'+CRLF+CRLF+oSql:Error(),'Ateno')
End   
retu(lRet)
/******************************************************************************/
STATIC Function CodGeral(cTabela, Campo, Tamanho)
/******************************************************************************/
LOCAL Max
  Max := 1
  oRow := oSql:Query( "Select "+Campo+" FROM " + cTabela[16,1] + " Order by "+Campo+" Desc" )
  oRow:Skip()
  Max := Val(left(oRow:Fieldget(oRow:Fieldpos(Campo)),Tamanho))+1
Return Max

/******************************************************************************/
STATIC Function RetornaDigito(X)
/******************************************************************************/
LOCAL Result, digitov, soma, w, c, resto, dig
  Result := digitov := ''
  soma := w := c := resto := dig := 0
  digitov := AllTrim(Str(x))
  dig := 0
  if len(digitov) <> 0 
     soma := 0
     c := len(digitov)
     w := len(digitov)+2
     Do While c <> 0 
        soma := soma+(Val(substr(digitov,c,1))*(w-c))
        c := c-1
        resto := Mod(soma, 11)
        dig := 11 - resto
        if (dig = 10) .or. (dig = 11)
           dig := 0
        Endif
     enddo
    Result := AllTrim(Str(dig,1,0))
  endif
Return Result
