/******************************************************************************  
 * Sistema .....: TestFB  
 * Programa ....:   
 * Autor .......: Wanderlei Cardoso de Oliveira  
 * Sintese .....: Exemplo FireBird  
 * Data ........: 28/03/2019 s 12:58:39  
 * Revisado em .: 28/03/2019 s 12:58:39  
 ******************************************************************************/  
#Include "hwgui.ch"

********************************************************************************
Procedure Main
********************************************************************************
LOCAL oDlg, oBrowse1, oButton1, aArray := {}

Public oDlgHabla:=nil, oDlgHabla2:=nil
*---> Variaveis de conexo com o banco de dados <---*
PUBLIC oSql, cHost:='localhost', cUsr:='sysdba', cPass:='masterkey', aTabelas, cnTable

*---> estabelece a conexo com o banco de dados <---*
if !file('fbclient.dll')
   MsgStop('o arquivo fbclient.dll no foi localizado!','Ateno')
   Return .F.
endif

if CONECTAR_SQL(cHost, cPass, cUsr, .F.)
   if file('PRODUTO.DBF')
      USE 'PRODUTO' Alias PRODUTO Shared New
      if PRODUTO->( RecCount() ) > 0 .and. MsgNoYes('Deseja inserir registros do produto na tabela?','Ateno')
         MsgProcHW('Aguarde, inserindo registros na tabela de produtos')
			nReg    := 0
			nTotReg := PRODUTO->( Reccount() )
			while PRODUTO->( !eof() )
			   vSql := "Insert Into PRODUTOS (PRCODI,PRDESC,CODBARRA,NOMELAB) Values ('"+PRODUTO->PRCODI+"', '"+alltrim(PRODUTO->PRDESC)+"', '"+alltrim(PRODUTO->CODBARRA)+"', '"+alltrim(PRODUTO->NOMELAB)+"')"
				oSql:StartTransaction()
				oSql:Execute( vSql )
		      oSql:Commit()
		      nReg++
				PRODUTO->( dbSkip() )
			enddo   
			MsgProcHWFim()
		endif
	endif
endif

xSQL_Query := 'Select * FROM PRODUTOS ORDER BY PRDESC'

oQuery := oSql:Query( xSQL_Query )
oQuery:Skip()
DO WHILE !oQuery:Eof()
   aadd(aArray,{oQuery:Fieldget(oQuery:Fieldpos('PRCODI'))  ,;
                oQuery:Fieldget(oQuery:Fieldpos('PRDESC'))  ,;
                oQuery:Fieldget(oQuery:Fieldpos('CODBARRA')),;
                oQuery:Fieldget(oQuery:Fieldpos('NOMELAB')) })
   oQuery:Skip()
ENDDO    

INIT DIALOG oDlg TITLE "Exemplo FireBird"    AT 0, 0 SIZE 456,282 NOEXIT  ;
   STYLE WS_POPUP+WS_CAPTION+WS_SYSMENU+WS_SIZEBOX+DS_CENTER 

   @ 13,14 BROWSE oBrowse1 ARRAY SIZE 429,209 STYLE WS_TABSTOP ;
   ON KEYDOWN {|o,key| BrowseKey(o, lastkey()) }

   oBrowse1:bColorSel := 16711680 //Cor da linha do browse
   oBrowse1:aArray    := aArray
   CreateArList( oBrowse1, aArray )
   oBrowse1:aColumns[1]:heading := "Cdigo"
   oBrowse1:aColumns[1]:length  := 10
   oBrowse1:aColumns[1]:width   := 100

   oBrowse1:aColumns[2]:heading := "Descrio"
   oBrowse1:aColumns[2]:length  := 30
   oBrowse1:aColumns[2]:width   := 300

   oBrowse1:aColumns[3]:heading := "Cdbarra"
   oBrowse1:aColumns[3]:length  := 10
   oBrowse1:aColumns[3]:width   := 100

   oBrowse1:aColumns[4]:heading := "Fabricante"
   oBrowse1:aColumns[4]:length  := 10
   oBrowse1:aColumns[4]:width   := 100

   oBrowse1:Refresh()

   @ 353,241 BUTTON oButton1 CAPTION "&Fechar"   SIZE 90,30 ;
        ON CLICK {|| EndDialog() } ;
		  STYLE BS_CENTER +WS_TABSTOP 

ACTIVATE DIALOG oDlg 

RETURN .T.

********************************************************************************
Static Function BrowseKey( oDlg, key )
********************************************************************************
IF key == VK_ESCAPE
   ENDDIALOG()
ENDIF

Return .T.

**********************************************************************************
FUNCTION CONECTAR_SQL(cHost, cPass, cUsr, lRestrutura)  //Conexo com o banco de dados
**********************************************************************************
LOCAL cServer:="", nError, lConectou:=.F., cLocalBanco:=""
	
	cLocalBanco := if(lower(ALLTRIM(cHost))=='localhost',CurDrive()+":\"+CurDir(),"\\"+lower(ALLTRIM(cHost))+"\"+CurDrive()+"\"+CurDir())

   cServer := cHost+":"+cLocalBanco+"\SFARMA.FDB"

   IF !FILE( cLocalBanco + "\SFARMA.FDB" )
      TRY                                                    // |-> 1024, 2048, 8192
			IF FBCreateDB(cLocalBanco + "\SFARMA.FDB", cUsr, cPass, 8192, 'ISO8859_1', 3 ) <> 1
            MsgStop("Falha na criao do banco","Ateno")              // |-> ASCII, ISO8859_1, ISO8859_2
            quit
         ENDIF
      CATCH
         MsgStop("ERRO na criao do banco","Ateno")
         quit
      END
   ENDIF 
  
   TRY
      oSql := TFBServer():New(cServer, cUsr, cPass, 3)
      
      if oSql:NetErr()
         MsgStop(oSql:Error(),"Ateno")
         quit
      end
   CATCH
      MsgStop("ERRO na conexo com o banco","Ateno")
      quit
   END

   IF lRestrutura
      MsgProcHW('Aguarde a restruturao das tabelas...')
		Restrutura_Table()
		MsgProcHWFim()
      MsgExclamation("Restruturao Concluida, Reinicie o sistema!","Ateno")
      Return .F.
   ELSE
      MsgProcHW('Aguarde a criao das tabelas...')
		CRIA_ARQUIVOS()
		MsgProcHWFim()
   ENDIF

RETURN (.T.)

********************************************************************************
FUNCTION MsgProcHW( cMsg, nLinha )
********************************************************************************
#include "hwgui.ch"
Local oFonte:= HFont():Add( "Arial" , 0 ,-15,500,255 ), cMsg1 := "", cMsg2 := ""

DEFAULT nLinha := 1

IF valtype(cMsg) == "A"
   cMsg1 := cMsg[1]
   if nLinha > 1
      cMsg2 := cMsg[2]
   endif
else
   cMsg1 := cMsg
ENDIF

INIT DIALOG oDlgHabla2 TITLE "Aguarde...";
     AT 0,0 SIZE 579, 60 NOEXITESC  NOCLOSABLE;
     STYLE WS_CAPTION+WS_POPUP+DS_SYSMODAL +DS_CENTER  ;
     ON INIT { || IniDlgHabla2() }

@ 0,0  SAY HB_AnsiToOem(cMsg1) SIZE 580, 32 STYLE SS_CENTER +DT_BOTTOM+DT_SINGLELINE ;
       FONT oFonte BACKCOLOR 16777215

IF !EMPTY(cMsg2)
   @ 0,32  SAY HB_AnsiToOem(cMsg1) SIZE 580, 32 STYLE SS_CENTER ;
       FONT oFonte BACKCOLOR 16777215
ENDIF

oDlgHabla2:Activate(.t.)

Return .T.

********************************************************************************
static FUNCTION IniDlgHabla2()
********************************************************************************
   oDlgHabla2:Center()
Return .T.

********************************************************************************
Function MsgProcHWFim()
********************************************************************************
   IF oDlgHabla2#NIL
      oDlgHabla2:CLOSE()
      oDlgHabla2:=NIL
   ENDIF
Return .T.
